<?php
/*
Plugin Name: CrisisPress Timestamp
Plugin URI: http://kaijia.me/crisispress
Description: Timestamp addon for CrisisPress
Version: Alpha
Author: Kaijia Feng
Author URI: http://kaijia.me
*/

function cpts_menu()
{
	add_menu_page(__('CrisisPress', 'cpts'), __('CrisisPress', 'cpts'), 'read', 'crisispress', 'cp_dashboard', '');
	$page = add_submenu_page('crisispress', __('Timestamp Session', 'cpts'), __('Timestamp', 'cpts'), 'read', 'crisispress-timestamp', 'cpts_screen');

	add_action('load-'.$page, 'cpts_help_tab');
	add_action('admin_print_footer_scripts-'.$page, 'cpts_add_js');
}
add_action('admin_menu', 'cpts_menu');

function cpts_screen()
{
	include_once('cpts-timestamp.php');
}

function cpts_help_tab()
{
	global $my_admin_page;
	$screen = get_current_screen();

	$screen->add_help_tab( array(
		'id'	=> 'cpts_help_tab',
		'title'	=> __('Timestamp Overview', 'cpts'),
		'content'	=> '<p>' . __( 'Add Session to a timestamp', 'cpts') . '</p>',
    ) );
}

function cpts_load_timepicker()
{
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'jquery-ui-core' );
	wp_enqueue_script( 'jquery-ui-datepicker' );
	wp_enqueue_script( 'jquery-ui-slider' );
	wp_enqueue_script( 'jquery-ui-timepicker', plugins_url('/timepicker/jquery-ui-timepicker-addon.js', __FILE__) );
}
//add_action('admin_enqueue_scripts', 'cpts_load_timepicker');

function the_virtual_time( $str = '', $time = '')
{
	if( empty( $time ) )
		$time = time();
	echo date( $str, cpts_time( $time ) );
}

/**
 * Get time in the virtual timeline
 * @param int a real timestamp
 * @return int a virtual timestamp 
 */
function cpts_time($time)
{
	global $wpdb;
	$day = $wpdb->get_var( $wpdb->prepare( "
			SELECT COUNT(*)
			FROM wp_cp_timestamp
			WHERE start <= $time;
		" ) );
	if ($day != 0) {
		$row = $wpdb->get_row( "
				SELECT *
				FROM wp_cp_timestamp
				WHERE end > $time AND start <= $time;
			" );
		//If now between 2 Sessions
		if( empty( $row ) ) {
			$row = $wpdb->get_row( "
				SELECT MAX(end)
				FROM wp_cp_timestamp
				WHERE end < $time;
			", ARRAY_A );
			$start = $row['MAX(end)'];
			$row = $wpdb->get_row( "
				SELECT MIN(start)
				FROM wp_cp_timestamp
				WHERE start > $time;
			", ARRAY_A );
			//Conference ended
			if( empty( $row ) ) {
				return ( $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM wp_cp_timestamp;" ) ) + 1 ) * 60 * 60;
			}
			$end = $row['MIN(start)'];
			$t_in = ( $time - $start ) / ( $end - $start ) * cpts_night_long();
			$t_to = $t_in + cpts_day_end();
			return $day * 24 * 60 * 60 + $t_to;
		} else {
			$start = $row->start;
			$end = $row->end;
			$t_in = ( $time - $start ) / ( $end - $start ) * cpts_day_long();
			$t_to = $t_in + cpts_day_start();
			return $day * 24 * 60 * 60 + $t_to;
		}
	} else {
		return cpts_day_start();
	}
}

/**
 * How long a virtual day lasts
 * @return int seconds
 */
function cpts_day_long()
{
	return 20 * 60 * 60;
}

/**
 * How long a virtual night lasts
 * @return int seconds
 */
function cpts_night_long()
{
	return 24 * 60 * 60 - cpts_day_long();
}

/**
 * When a virtual day starts
 * @return int seconds
 */
function cpts_day_start()
{
	return 2 * 60 * 60;
}

/**
 * When a virtual day ends
 * @return int seconds
 */
function cpts_day_end()
{
	return 22 * 60 * 60;
}
?>